Package: ecolitk
Version: 1.84.0
Date: 2010-04
Title: Meta-data and tools for E. coli
Author: Laurent Gautier
Maintainer: Laurent Gautier <lgautier@gmail.com>
biocViews: Annotation, Visualization
Depends: R (>= 2.10)
Imports: Biobase, graphics, methods
Suggests: ecoliLeucine, ecolicdf, graph, multtest, affy
Description: Meta-data and tools to work with E. coli. The tools are
        mostly plotting functions to work with circular genomes. They
        can used with other genomes/plasmids.
License: GPL (>= 2)
git_url: https://git.bioconductor.org/packages/ecolitk
git_branch: RELEASE_3_23
git_last_commit: aef6a78
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:53:02 UTC; biocbuild

### R code from vignette source 'ecolitk.Rnw'

###################################################
### code chunk number 1: ecolitk.Rnw:58-59
###################################################
library(ecolitk)


###################################################
### code chunk number 2: ecolitk.Rnw:70-72
###################################################
data(ecoligenomeSYMBOL2AFFY)
data(ecoligenomeCHRLOC)


###################################################
### code chunk number 3: ecolitk.Rnw:81-87
###################################################
lac.i <- grep("^lac", ls(ecoligenomeSYMBOL2AFFY))
lac.symbol <- ls(ecoligenomeSYMBOL2AFFY)[lac.i]
lac.affy <- unlist(lapply(lac.symbol, get, envir=ecoligenomeSYMBOL2AFFY))

beg.end <- lapply(lac.affy, get, envir=ecoligenomeCHRLOC)
beg.end <- matrix(unlist(beg.end), nc=2, byrow=TRUE)


###################################################
### code chunk number 4: ecolitk.Rnw:92-126
###################################################
par(mfrow=c(2,2))
n <- 10
thetas <- rev(seq(0, 2 * pi, length=n))

rhos <- rev(seq(1, n) / n)

xy <- polar2xy(rhos, thetas)
colo <- heat.colors(n)

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n")
for (i in 1:n)
  linesCircle(rhos[i]/2, xy$x[i], xy$y[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n")
for (i in 1:n)
  polygonDisk(rhos[i]/2, xy$x[i], xy$y[i], col=colo[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n", xlab="", ylab="")
for (i in 1:n)
  polygonArc(0, thetas[i],
             rhos[i]/2, rhos[i],
             center.x = xy$x[i], center.y = xy$y[i], col=colo[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n", xlab="", ylab="")
for (i in (1:n)[-1]) {
  linesCircle(rhos[i-1], col="gray", lty=2)
  polygonArc(thetas[i-1], thetas[i],
             rhos[i-1], rhos[i], col=colo[i],
             edges=20)
  arrowsArc(thetas[i-1], thetas[i],
             rhos[i] + 1, col=colo[i],
             edges=20)
}
  


###################################################
### code chunk number 5: ecolitk.Rnw:134-135
###################################################
cPlotCircle(main.inside = "E. coli - K12")


###################################################
### code chunk number 6: ecolitk.Rnw:146-152
###################################################
lac.o <- order(beg.end[, 1])

lac.i <- lac.i[lac.o]
lac.symbol <- lac.symbol[lac.o]
lac.affy <- lac.affy[lac.o]
beg.end <- beg.end[lac.o, ]


###################################################
### code chunk number 7: ecolitk.Rnw:156-158
###################################################
cPlotCircle(main.inside = "E. coli - K12", main = "lac genes")
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.4)


###################################################
### code chunk number 8: ecolitk.Rnw:162-166
###################################################
l <- data.frame(x=c(0.470, 0.48), y=c(0.87, 0.90))
cPlotCircle(xlim=range(l$x), ylim=range(l$y), main = "lac genes")
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.007, col=rainbow(4))
legend(0.47, 0.9, legend=lac.symbol, fill=rainbow(4))


###################################################
### code chunk number 9: ecolitk.Rnw:177-211
###################################################
library(Biobase)
data(ecoligenomeBNUM2STRAND)
data(ecoligenomeBNUM)
data(ecoligenomeBNUM2MULTIFUN)
data(ecoligenomeCHRLOC)

affyids <- ls(ecoligenomeCHRLOC)
affypos <- mget(affyids, ecoligenomeCHRLOC, ifnotfound=NA)
## 'unlist' as the mapping is one-to-one
bnums <- unlist(mget(affyids, ecoligenomeBNUM, ifnotfound=NA)) 
strands <- unlist(mget(bnums, ecoligenomeBNUM2STRAND, ifnotfound=NA))
##
multifun <- mget(bnums, ecoligenomeBNUM2MULTIFUN, ifnotfound=NA)

## select the entries in the categorie "1.6"
## ("Macromolecules (cellular constituent)  biosynthesis")
f <- function(x) {
  if (all(is.na(x)))
    return(FALSE)
  length(grep("^1\\.6", x) > 0)
}

is.selected <- unlist(lapply(multifun, f))
                              
cPlotCircle(main.inside="E.coli K12")
beg.end <- matrix(unlist(affypos), nc=2, byrow=TRUE)
## plot 'bnums'... strand +
good <- strands == ">" & is.selected
linesChrom(beg.end[good, 1], beg.end[good, 2],
             ecoli.len, 1.4, col="red", lwd=3)
## plot 'bnums'... strand -
good <- strands == "<" & is.selected
linesChrom(beg.end[good, 1], beg.end[good, 2],
           ecoli.len, 1.5, col="blue", lwd=3)


###################################################
### code chunk number 10: ecolitk.Rnw:280-289
###################################################
library(Biobase)
data(ecoligenome.operon)
data(ecoligenomeSYMBOL2AFFY)

tmp <- mget(ecoligenome.operon$gene.name,
         ecoligenomeSYMBOL2AFFY, ifnotfound=NA)
ecoligenome.operon$affyid <- unname(unlist(tmp))
# clean up NAs
ecoligenome.operon <- subset(ecoligenome.operon, !is.na(affyid))


###################################################
### code chunk number 11: ecolitk.Rnw:298-304
###################################################
attach(ecoligenome.operon)
affyoperons <- split(affyid, operon.name)
detach(ecoligenome.operon)

## a sample of 5 operons
affyoperons[18:22]


###################################################
### code chunk number 12: ecolitk.Rnw:308-309
###################################################
library(affy)


###################################################
### code chunk number 13: ecolitk.Rnw:313-316
###################################################
library(ecoliLeucine)

data(ecoliLeucine)


###################################################
### code chunk number 14: ecolitk.Rnw:320-321
###################################################
abatch.nqt <- normalize(ecoliLeucine, method="quantiles")


###################################################
### code chunk number 15: ecolitk.Rnw:325-333
###################################################
## the operon taken as an example:
names(affyoperons)[18]
#colnames(abatch.nqt@exprs) <- NULL
eset <- computeExprSet(abatch.nqt, 
                       pmcorrect.method="pmonly", 
                       summary.method="medianpolish", 
                       ids = affyoperons[[18]])



###################################################
### code chunk number 16: computeExprSetOperon
###################################################
operons.eset <- computeExprSet(abatch.nqt, 
                               pmcorrect.method="pmonly", 
                               summary.method="medianpolish", 
                               ids = unlist(affyoperons))



###################################################
### code chunk number 17: ecolitk.Rnw:348-365
###################################################
library(multtest)

my.ttest <- function(x, i, j) {
  pval <- t.test(x[i], x[j])$p.value
  return(pval)
}

is.lrpplus <- pData(operons.eset)$strain == "lrp+"
is.lrpmoins <- pData(operons.eset)$strain == "lrp-"

operons.ttest <- esApply(operons.eset, 1, my.ttest, is.lrpplus, is.lrpmoins)

## adjustment for multiple testing.
operons.ttest.adj <- mt.rawp2adjp(operons.ttest, "BY")$adjp

## flag whether or not the probeset can be considered differentially expressed
operons.diff.expr <- operons.ttest.adj < 0.01


###################################################
### code chunk number 18: ecolitk.Rnw:370-371
###################################################
operons.i <- split(seq(along=operons.ttest), ecoligenome.operon$operon.name)

wstringapply <- function(x, SIZE, SLIDE, FUN, ...) {
  n <- (nchar(x) - SIZE) %/% SLIDE
  res <- vector("list", length = n)
  for (i in seq(0, n-1, length=n)) {
    ##x.start <- (i-1) * SIZE + 1
    ##x.stop <- min(nchar(x), i * SIZE)
    w.x <- substring(x, i * SLIDE + 1, i * SLIDE + SIZE)
    res[[i+1]] <- FUN(w.x, ...)
    ##res[[i]] <- FUN(w.x)
  }
  return(res)
}

# wapply <- function(x, SIZE, FUN, ...) {
#   n <- length(x)
#   res <- vector("list", length = n-1)
#   for (i in seq(1, n-1, length=n-1)) {
#     w.x <- x[i, i+SIZE]
#     res[[i]] <- FUN(w.x, ...)
#     ##res[[i]] <- FUN(w.x)
#   }
#   return(res)
# }

gccontent <- function(x) {x <- toupper(x); n <- nchar(x); sum(as.integer(strsplit(x, "")[[1]] %in% c("G", "C")))/n}

xy2polar <- function(x, y) {
  if (missing(y)) {
    y <- x$y
    x <- x$x
  }
  rho <- sqrt(x^2 + y^2)
  theta <- atan(y/x)
  return(list(rho=rho, theta=theta))
}

polar2xy <- function(rho, theta) {
  if (missing(theta)) {
    theta <- rho$theta
    rho <- rho$rho
  }
  x <- rho * cos(theta)
  y <- rho * sin(theta)
  return(list(x=x, y=y))
}

rotate <- function(x, y, alpha) {
  pol <- xy2polar(x, y)
  pol$theta <- pol$theta + alpha
  xy <- polar2xy(pol)
  return(xy)
}
                    

cPlotCircle <- function(radius=1, xlim=c(-2, 2), ylim=xlim, edges=300, main=NULL, main.inside=NULL, ...) {
  plot.new()
  plot.window(xlim, ylim, ...)
  linesCircle(radius, edges=edges, ...)
  title(main)
  text(0, 0, main.inside)
}

linesCircle <- function(radius, center.x = 0, center.y = 0, edges=300, ...) {
  xy <- polar2xy(radius, seq(0, 2*pi, length=edges))
  ##x <- (radius * cos(seq(0, 2*pi, length=edges))) + center.x
  ##y <- (radius * sin(seq(0, 2*pi, length=edges))) + center.y
  lines(xy$x + center.x, xy$y + center.y, ...)
}

chromPos2angle <- function(pos, len.chrom, rot=pi/2, clockwise=TRUE) {
  if (any(abs(pos) > len.chrom, na.rm=TRUE))
    warning(paste(pos, ">", len.chrom, ": abs(pos) > len.chrom !!!"))
  
  theta <- pos * 2 * pi / len.chrom
  
  if (clockwise)
    theta <- - theta

  theta <- theta + rot

  return(theta)
}

polygonDisk <- function(radius, center.x=0, center.y=0, edges=300, ...) {
  ##x <- (radius * cos(seq(0, 2*pi, length=edges))) + center.x
  ##y <- (radius * sin(seq(0, 2*pi, length=edges))) + center.y
  
  xy <- polar2xy(radius, seq(0, 2*pi, length=edges))
  polygon(xy$x + center.x, xy$y + center.y, ...)
  
}

# linesPolar <- function(theta, radius, center.x = 0, center.y = 0, ...) {
#   xy <- polar2xy(radius, theta0, theta1, length=edges))
#   xy$x <- xy$x + center.x
#   xy$y <- xy$y + center.y
#   lines(xy$x, xy$y, ...)
# }

pointsArc <- function(theta0, theta1, radius, center.x = 0, center.y = 0, ...) {
  xy <- polar2xy(radius, seq(theta0, theta1, length=length(radius)))
  ##x <- (radius * cos(seq(0, 2*pi, length=edges))) + center.x
  ##y <- (radius * sin(seq(0, 2*pi, length=edges))) + center.y
  points(xy$x + center.x, xy$y + center.y, ...)
}

linesArc <- function(theta0, theta1, radius, center.x = 0, center.y = 0, ...) {
  xy <- polar2xy(radius, seq(theta0, theta1, length=length(radius)))
  ##x <- (radius * cos(seq(0, 2*pi, length=edges))) + center.x
  ##y <- (radius * sin(seq(0, 2*pi, length=edges))) + center.y
  lines(xy$x + center.x, xy$y + center.y, ...)
}

arrowsArc <- function(theta0, theta1, radius, center.x = 0, center.y = 0, edges = 10,
                      length = 0.25, angle = 30, code = 2, ...) {
  xy <- polar2xy(radius, seq(theta0, theta1, length=edges))
  xy$x <- xy$x + center.x
  xy$y <- xy$y + center.y
  lines(xy$x, xy$y, ...)
  n <- length(xy$x)
  if (code == 2 | code == 3)
    arrows(xy$x[n-1], xy$y[n-1], xy$x[n], xy$y[n], length=length, angle=angle, ...)
  if (code == 1 | code == 3)
    arrows(xy$x[1], xy$y[1], xy$x[2], xy$y[2], length=length, angle=angle, ...)
  
}

polygonArc <- function(theta0, theta1, radius.in, radius.out,
                       center.x = 0, center.y = 0,
                       edges=10,
                       col="black",
                       border = NA,
                       ...) {
  
  
  if (length(edges) == 1)
    edges <- rep(edges, length=length(theta0))

  col <- rep(col, length = length(theta0))

  ok <- ! (is.na(theta0) | is.na(theta1))
  
  for (i in seq(along=theta0[ok])) {
    theta.seq <- seq(theta0[ok][i], theta1[ok][i], length=edges[ok][i])
    x <- c(radius.in * cos(theta.seq), radius.out * cos(rev(theta.seq))) + center.x 
    y <- c(radius.in * sin(theta.seq), radius.out * sin(rev(theta.seq))) + center.y
    polygon(x, y, col=col[ok][i], border=border, ...)
  }
}

polygonChrom <- function(begin, end, len.chrom,
                         radius.in, radius.out,
                         total.edges=300,
                         edges=max(round(abs(end-begin)/len.chrom* total.edges), 2, na.rm=TRUE),
                         rot=pi/2, clockwise=TRUE,
                         ...) {

  theta0 <- chromPos2angle(begin, len.chrom, rot=rot, clockwise=clockwise)
  theta1 <- chromPos2angle(end, len.chrom, rot=rot, clockwise=clockwise)

  if (any(theta0 == theta1, na.rm=TRUE))
    warning(paste("identical angles for: ", which(theta0 == theta1), collapse=TRUE))
  
  polygonArc(theta0, theta1, radius.in, radius.out, edges=edges, ...)
}

linesChrom <- function(begin, end, len.chrom, radius,
                       total.edges=300,
                       edges=max(round(abs(end-begin)/len.chrom* total.edges), 2, na.rm=TRUE),
                       rot=pi/2, clockwise=TRUE,
                       ...) {

  theta0 <- chromPos2angle(begin, len.chrom, rot=rot, clockwise=clockwise)
  theta1 <- chromPos2angle(end, len.chrom, rot=rot, clockwise=clockwise)

  if (any(theta0 == theta1, na.rm=TRUE))
    warning(paste("identical angles for: ", which(theta0 == theta1), collapse=TRUE))

  if (length(edges) == 1)
    edges <- rep(edges, length=length(theta0))

  ok <- ! (is.na(theta0) | is.na(theta1))
  
  for (i in seq(along=theta0[ok])) {
    linesArc(theta0[ok][i], theta1[ok][i], rep(radius, edges[ok][i]), ...)
  }
}

ecoli.len <- 4639221

.buildBNUM2GENBANK <- function() {
  return(.buildGENEPRODFUN(what="genbank"))
}

.buildBNUM2GENEPRODUCT <- function() {
  return(.buildGENEPRODFUN(what="gene product"))
}

.buildGENEPRODFUN <- function(my.file=NULL, my.url="http://genprotec.mbl.edu/files/geneproductfunctions.txt", what="") {
  choices <- c("bnum", "genbank", "gene", "gene type", "gene product")
  what <- match.arg(what, choices)
  what.i <- match(what, choices)
  env.x2y <- new.env(hash=TRUE)
  ##env.genbank <- new.env(hash=TRUE)
  if (is.null(my.file))
    con <- url(my.url, open="r")
  else
    con <- file(my.file, open="r")

  ## skip comments
  mycomments <- ""
  line <- readLines(con, n=1)
  while (length(grep("^bnum", line)) == 0) {
    line <- readLines(con, n=1)
    mycomments <- paste(mycomments, line, sep="\n")
  }
  mycomments <- paste(mycomments, "\n", sep="")
  line <- readLines(con, n=1)

  ##
  while (length(line) != 0) {
    if (line != "") {
      m <- strsplit(line, "\t", extended=TRUE)[[1]]
      bnum <- m[1]
      genbank <- m[what.i]
      if (genbank == "0")
        genbank <- NA
      if (exists(bnum, envir=env.x2y))
        assign(bnum, unique(c(genbank, get(bnum, envir=env.x2y))), envir=env.x2y)
      else
        assign(bnum, genbank, envir=env.x2y)
    }
    line <- readLines(con, n=1)
  }

  attr(env.x2y, "comments") <- mycomments
  return(env.x2y)

}


.buildMultiFun <- function(my.file=NULL, my.url="http://genprotec.mbl.edu/files/MultiFun.txt") {
  env.multiFun <- new.env(hash=TRUE)

  if (is.null(my.file))
    con <- url(my.url, open="r")
  else
    con <- file(my.file, open="r")

  ## skip comments
  mycomments <- ""
  line <- readLines(con, n=1)
  while (length(grep("^[0-9]", line)) == 0) {
    line <- readLines(con, n=1)
    mycomments <- paste(mycomments, line, sep="\n")
  }
  mycomments <- paste(mycomments, "\n", sep="")

  ##
  while (length(line) != 0) {
    if (line != "") {
      ## trim leading white spaces
      m <- regexpr("(\\w\\.?)+", line, perl=TRUE)
      multiFun <- substr(line, m, m+attr(m, "match.length")-1)
      multiFun <- sub("\\.$", "", multiFun)
      multiFunAnnotation <- substr(line, m + attr(m, "match.length") + 1, nchar(line))
      assign(multiFun, multiFunAnnotation, envir=env.multiFun)
    }
    line <- readLines(con, n=1)
  }
  attr(env.multiFun, "comments") <- mycomments
  return(env.multiFun)
}

.buildBNUM2MULTIFUN <- function(my.file=NULL, my.url="http://genprotec.mbl.edu/files/multifunassignments.txt") {
  env.bnum2multifun <- new.env(hash=TRUE)

  if (is.null(my.file))
    con <- url(my.url, open="r")
  else
    con <- file(my.file, open="r")

  ## skip comments
  mycomments <- ""
  line <- readLines(con, n=1)
  while (length(grep("^Bnum", line)) == 0) {
    line <- readLines(con, n=1)
    mycomments <- paste(mycomments, line, sep="\n")
  }
  mycomments <- paste(mycomments, "\n", sep="")
  line <- readLines(con, n=1)

  ##
  while (length(line) != 0) {
    if (line != "") {
      ## trim leading white spaces
      m <- regexpr("b\\d+", line, perl=TRUE)
      bnum <- substr(line, m, m+attr(m, "match.length")-1)
      m <- regexpr("\\s\\S+", line, perl=TRUE)
      multiFun <- substr(line, m+1, m+attr(m, "match.length")-1)
      if (exists(bnum, envir=env.bnum2multifun))
        assign(bnum, unique(c(multiFun, get(bnum, envir=env.bnum2multifun))), envir=env.bnum2multifun)
      else
        assign(bnum, multiFun, envir=env.bnum2multifun)
    }
    line <- readLines(con, n=1)
  }

  return(env.bnum2multifun)
}

.buildBNUM2SYMBOL <- function(my.url="http://genprotec.mbl.edu/files/MultiFun.txt") {

}

.buildMULTIFUN2GO <- function(filename) {
  env.multiFun2GO <- new.env(hash=TRUE)
  con <- file(filename, open="r")

  ## skip comments
  mycomments <- ""
  line <- readLines(con, n=1)
  while (length(grep("^!", line)) > 0) {
      line <- readLines(con, n=1)
      mycomments <- paste(mycomments, line, sep="\n")
    }
  mycomments <- paste(mycomments, "\n", sep="")
  ##

  while (length(line) != 0) {
    ## get MultiFun number
    m <- regexpr("^MultiFun:(\\.+?) ", line, perl=TRUE)
    multiFun <- substr(line, 10, attr(m, "match.length") - 1)
    ## get the GOs
    m <- regexpr("> \\.+$", line, perl=TRUE)
    GOs <- substr(line, m+2, m+attr(m, "match.length"))
    if (GOs == "GO:.") {
      ## no go ;)
      GOs <- NA
    } else {
      GOs <- strsplit(GOs, " > ")[[1]]
      GOs <- strsplit(GOs, " ; ")
      GOs <- unlist(lapply(GOs, function(x) x[2]))
    }
    assign(multiFun, GOs, envir=env.multiFun2GO)

    line <- readLines(con, n=1)
  }
  attr(env.multiFun2GO, "comments") <- mycomments
  return(env.multiFun2GO)
}


.buildMultiFunGraphNEL <- function(filename) {
  require("graph") || stop("The graph packages is needed for this operation")

  nid.i <- 1
  nname.i <- 2

  linesInFile <- readLines(filename)

  tmp <- strsplit(linesInFile, ";")

  r <- lapply(tmp, function(x, y) strsplit(x[nid.i], y), "\\.")
  r.names <- unlist(lapply(tmp, function(x, y) x[nname.i]))

  mFunNodenames <- unique(unlist(lapply(tmp, function(x) x[nname.i])))
  nodename2i <- new.env(hash=TRUE)
  nodename2nodeid <- new.env(hash=TRUE)
  nodeid2nodename <- new.env(hash=TRUE)

  multiassign(mFunNodenames, seq(along=mFunNodenames), nodename2i)
  mFunEdges <- vector("list", length=length(mFunNodenames))
  names(mFunEdges) <- mFunNodenames
  multiassign(unlist(lapply(tmp, function(x) x[nid.i])), unlist(lapply(tmp, function(x) x[nname.i])),
              envir=nodeid2nodename)

  for (i in seq(along=r)) {
    n <- length(r[[i]][[1]])
    if (n == 1)
      next
    parent <- paste(r[[i]][[1]][seq(1, n-1, length=n-1)], collapse=".")
    if (! exists(parent, nodeid2nodename))
      next
    parent.i <- get(get(parent, nodeid2nodename), nodename2i)
    child.i <- get(tmp[[i]][nname.i], nodename2i)
    ##parent.i <- get(get(parent, nodeid2nodename), nodename2i)
    ##child.i <- i
    if (is.null(mFunEdges[[parent.i]])) {
      mFunEdges[[parent.i]]$edges = child.i
      mFunEdges[[parent.i]]$weights = 1
    } else {
      mFunEdges[[parent.i]]$edges = c(mFunEdges[[parent.i]]$edges, child.i)
      mFunEdges[[parent.i]]$weights = c(mFunEdges[[parent.i]]$weights, 1)
    }

    if (is.null(mFunEdges[[child.i]])) {
      ##meshedges[[child.i]]$edges = parent.i
###meshedges[[parent.i]]$edges = paste(r[[i]][[1]], collapse=".")
                                        #meshedges[[child.i]]$weights = 1
    } else {
###meshedges[[parent.i]]$edges = c(meshedges[[parent.i]]$edges, paste(r[[i]][[1]], collapse="."))
      ##meshedges[[child.i]]$edges = c(meshedges[[child.i]]$edges, parent.i)
      ##meshedges[[child.i]]$weights = c(meshedges[[child.i]]$weights, 1)
    }
  }

  ##meshnodenames <- seq(along=meshnodenames)
  ##names(meshedges) <- meshnodenames

  gmesh <- new("graphNEL", nodes=mFunNodenames, edgeL=mFunEdges, edgemode="directed")

  return(gmesh)
}


linkedmultiget <- function(x, envir.list=list(), unique=TRUE) {

  if (! is.character(x))
    stop("x must be a vector of mode 'character'")

  f <- function(x, y) {
    tmp <- mget(x, envir=y, ifnotfound=NA)
    tmp <- unlist(tmp)
    if (all(is.na(tmp)))
      tmp <- as.character(tmp)
    if (! is.character(tmp))
      stop("Values in environments must be of mode 'character'")
    return(tmp)
  }

  ##r <- vector("list", length=length(x))
  r <- as.list(x)
  for (i in seq(along=envir.list)) {
    r <- lapply(r, f, envir.list[[i]])
    if (unique)
      r <- lapply(r, unique)
  }
  names(r) <- x
  return(r)
}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{ecolitk}
%\VignetteKeywords{}
%\VignetteDepends{ecolitk, Biobase, multtest}
%\VignettePackage{ecolitk}
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage[authoryear,round]{natbib}
\usepackage{hyperref}


\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}

\bibliographystyle{plainnat}

\author{Laurent}
\begin{document}
\title{A package to work with {\it E. coli} genome (and other circular
DNA entities)}
\maketitle

\section*{Introduction}

This package is a mixture of data (close the the data in the meta-data
packages) and of code. The code was not included in other packages
because:
\begin{itemize}
  \item much is still to be done, much is likely to change.
  \item some features do are appear completely compatible with what is
  existing elsewhere
\end{itemize}
Things will settle in time\ldots

The package contains data on {\it Escherichia coli} but can be used with
other bacterial genomes or plamids, provided one supplies the required
data.

To load the package, do:
\begin{Sinput}
R> library(ecolitk)
\end{Sinput}
<<echo=F,results=hide>>=
library(ecolitk)
@

\section*{{\it E. coli} data}
Data related to {\it E. coli} are included in the package. Effort was
made to follow the convention used in the meta-data packages available
on bioconductor. On should refer to the help files for further details.

In the following example, we explain how to find the positions of the genes
of the operon lactose on the genome.
A first step is to load needed data structures:
<<>>=
data(ecoligenomeSYMBOL2AFFY)
data(ecoligenomeCHRLOC)
@
This done, we want to find the genes with names like \verb+lac*+.
The \Rpackage{base} function \Rfunction{grep} provides a convenient
way to do it. Because the data structures are centered on Affymetrix
probeset identifiers, an extra step is need to convert the gene name
into the corresponding identifier. The locations of the genes can
then be extracted from the environment \Robject{ecoligenomeCHRLOC}.
We store them in the \Robject{beg.end}.
<<>>=
lac.i <- grep("^lac", ls(ecoligenomeSYMBOL2AFFY))
lac.symbol <- ls(ecoligenomeSYMBOL2AFFY)[lac.i]
lac.affy <- unlist(lapply(lac.symbol, get, envir=ecoligenomeSYMBOL2AFFY))

beg.end <- lapply(lac.affy, get, envir=ecoligenomeCHRLOC)
beg.end <- matrix(unlist(beg.end), nc=2, byrow=TRUE)
@ 

\section*{Primitives for circular entities}

<<fig=TRUE>>=
par(mfrow=c(2,2))
n <- 10
thetas <- rev(seq(0, 2 * pi, length=n))

rhos <- rev(seq(1, n) / n)

xy <- polar2xy(rhos, thetas)
colo <- heat.colors(n)

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n")
for (i in 1:n)
  linesCircle(rhos[i]/2, xy$x[i], xy$y[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n")
for (i in 1:n)
  polygonDisk(rhos[i]/2, xy$x[i], xy$y[i], col=colo[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n", xlab="", ylab="")
for (i in 1:n)
  polygonArc(0, thetas[i],
             rhos[i]/2, rhos[i],
             center.x = xy$x[i], center.y = xy$y[i], col=colo[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n", xlab="", ylab="")
for (i in (1:n)[-1]) {
  linesCircle(rhos[i-1], col="gray", lty=2)
  polygonArc(thetas[i-1], thetas[i],
             rhos[i-1], rhos[i], col=colo[i],
             edges=20)
  arrowsArc(thetas[i-1], thetas[i],
             rhos[i] + 1, col=colo[i],
             edges=20)
}
  
@

\section*{Plotting toolbox for circular genomes}

\subsection*{Plot a (circular) genome}

The function \Rfunction{cPlotCircle} draws a circular chromosome.
<<fig=TRUE>>=
cPlotCircle(main.inside = "E. coli - K12")
@

The drawing of the chromosome is thought as a first step when plotting
informations on a circular genome. The following example shows how
to plot the locations of the genes for the operon lactose on the genome.
(the steps leading to their respective positions were detailed above).

\subsection*{plot genes on a genome}
We sort the genes the \verb+lac*+ genes discussed in an example above 
according to their positions on the genome.
<<>>=
lac.o <- order(beg.end[, 1])

lac.i <- lac.i[lac.o]
lac.symbol <- lac.symbol[lac.o]
lac.affy <- lac.affy[lac.o]
beg.end <- beg.end[lac.o, ]
@

This done, we plot them as polygons:
<<fig=TRUE>>=
cPlotCircle(main.inside = "E. coli - K12", main = "lac genes")
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.4)
@
Zoom in can be achieved by playing with \Rfunarg{xlim} and \Rfunarg{ylim}.

<<fig=TRUE>>=
l <- data.frame(x=c(0.470, 0.48), y=c(0.87, 0.90))
cPlotCircle(xlim=range(l$x), ylim=range(l$y), main = "lac genes")
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.007, col=rainbow(4))
legend(0.47, 0.9, legend=lac.symbol, fill=rainbow(4))
@ 

\subsection*{More plots}

The following plot uses several different annotation sources.

It tries to show a spatial pattern for the genes annotated as
- Macromolecules (cellular constituent)  biosynthesis -.
In the following plot those genes are plotted according to their
position on the genome and according to their respective strand.
<<fig=TRUE>>=
library(Biobase)
data(ecoligenomeBNUM2STRAND)
data(ecoligenomeBNUM)
data(ecoligenomeBNUM2MULTIFUN)
data(ecoligenomeCHRLOC)

affyids <- ls(ecoligenomeCHRLOC)
affypos <- mget(affyids, ecoligenomeCHRLOC, ifnotfound=NA)
## 'unlist' as the mapping is one-to-one
bnums <- unlist(mget(affyids, ecoligenomeBNUM, ifnotfound=NA)) 
strands <- unlist(mget(bnums, ecoligenomeBNUM2STRAND, ifnotfound=NA))
##
multifun <- mget(bnums, ecoligenomeBNUM2MULTIFUN, ifnotfound=NA)

## select the entries in the categorie "1.6"
## ("Macromolecules (cellular constituent)  biosynthesis")
f <- function(x) {
  if (all(is.na(x)))
    return(FALSE)
  length(grep("^1\\.6", x) > 0)
}

is.selected <- unlist(lapply(multifun, f))
                              
cPlotCircle(main.inside="E.coli K12")
beg.end <- matrix(unlist(affypos), nc=2, byrow=TRUE)
## plot 'bnums'... strand +
good <- strands == ">" & is.selected
linesChrom(beg.end[good, 1], beg.end[good, 2],
             ecoli.len, 1.4, col="red", lwd=3)
## plot 'bnums'... strand -
good <- strands == "<" & is.selected
linesChrom(beg.end[good, 1], beg.end[good, 2],
           ecoli.len, 1.5, col="blue", lwd=3)
@ 

\subsection*{More complex plot}
The next example is more complex: we want to compute and
display the GC content over a fragment of the genome.
The fragment is decided to be of size $1$ million bases,
with the origin of replication (base zero) in the middle
of the fragment. We limit the size to lower the computing
resources needed to built this document and to demonstrate
how to perform something not so trivial.

\begin{Scode}
cPlotCircle(main.inside = "E. coli - K12")

data(ecoli.m52.genome)
size.frag <- 1000000

fragment.r <- substring(ecoli.m52.genome, 1, size.frag/2)
fragment.l <- substring(ecoli.m52.genome, ecoli.len - size.frag / 2, ecoli.len)
fragment <- paste(fragment.l, fragment.r, sep="")
library(matchprobes)
tmp <- wstringapply(fragment, 400, 200, basecontent)
gccontent <- unlist(lapply(tmp, function(x) sum(x[3:4]) / sum(x)))

theta0 <- chromPos2angle(0 - size.frag/2, ecoli.len)
theta1 <- chromPos2angle(size.frag/2, ecoli.len)

linesCircle(1.5, col="gray", lty = 2)
linesArc(theta0, theta1, gccontent + 1)
\end{Scode}

Zooming can be performed by setting the \Rfunarg{xlim} and
\Rfunarg{ylim} parameters of the function \Rfunction{cPlotCircle}.
In our example, there seem to be a CG rich island we would like to
have a closer look at:

\begin{Scode}
par(mfrow=c(1,2))
cPlotCircle(main.inside = "E. coli - K12")
l <- data.frame(x=c(-0.7737990, -0.5286815), y=c(1.521509, 1.304151))
linesCircle(1.5, col="gray", lty = 2)
linesArc(theta0, theta1, gccontent + 1)
rect(l$x[1], l$y[1], l$x[2], l$y[2], border="red")

cPlotCircle(xlim=range(l$x), ylim=range(l$y))
box(col="red")
linesCircle(1.5, col="gray", lty = 2)
linesArc(theta0, theta1, gccontent + 1)
\end{Scode}

As the parameter \Rfunarg{SLIDE} was set to 200, one can
estimate from the close up that the size of the island is roughly over 1500
base pairs.

\section*{Genes in operons}

In procaryotes, some genes are {\it bundled} in operons. This means that
a some genes are physically located near each others on the genome,
and that they are transcribed\footnote{The {\it transcription} is the
  copy of DNA into RNA} together. Complex mechanisms can regulate
the translation\footnote{The {\it translation} is the making of a
protein from RNA}. Microarrays are designed to measure the relative abundance
of transcripts, therefore genes of the same operon should have the
same expression level.


First one has to find the Affymetrix identifiers for the genes known
to be in operons:
<<>>= 
library(Biobase)
data(ecoligenome.operon)
data(ecoligenomeSYMBOL2AFFY)

tmp <- mget(ecoligenome.operon$gene.name,
         ecoligenomeSYMBOL2AFFY, ifnotfound=NA)
ecoligenome.operon$affyid <- unname(unlist(tmp))
# clean up NAs
ecoligenome.operon <- subset(ecoligenome.operon, !is.na(affyid))
@ 
For convenience, the Affymetrix probe set identifiers are stored in
the \Rclass{data.frame}. As an exercise, the reader can write the few
lines of code needed to plot the operon on the genome (see above for
plotting examples).

Once this done, grouping the Affymetrix identifiers according to the
operon they belong to is done simply:
<<>>=
attach(ecoligenome.operon)
affyoperons <- split(affyid, operon.name)
detach(ecoligenome.operon)

## a sample of 5 operons
affyoperons[18:22]
@ 

Since we are going to use Affymetrix data, loading the affy package is needed:
<<>>=
library(affy)
@ 

A bioconductor package of experimental E.coli data is used:
<<>>=
library(ecoliLeucine)

data(ecoliLeucine)
@ 

First, one should normalize the data:
<<>>=
abatch.nqt <- normalize(ecoliLeucine, method="quantiles")
@ 

The summary statistics for a probe set can be obtained simply:
<<>>=
## the operon taken as an example:
names(affyoperons)[18]
#colnames(abatch.nqt@exprs) <- NULL
eset <- computeExprSet(abatch.nqt, 
                       pmcorrect.method="pmonly", 
                       summary.method="medianpolish", 
                       ids = affyoperons[[18]])

@ 


<<label=computeExprSetOperon>>=
operons.eset <- computeExprSet(abatch.nqt, 
                               pmcorrect.method="pmonly", 
                               summary.method="medianpolish", 
                               ids = unlist(affyoperons))

@ 

We assumed that genes within operons should be all differentially
expressed, or all not differentially expressed. 

<<>>=
library(multtest)

my.ttest <- function(x, i, j) {
  pval <- t.test(x[i], x[j])$p.value
  return(pval)
}

is.lrpplus <- pData(operons.eset)$strain == "lrp+"
is.lrpmoins <- pData(operons.eset)$strain == "lrp-"

operons.ttest <- esApply(operons.eset, 1, my.ttest, is.lrpplus, is.lrpmoins)

## adjustment for multiple testing.
operons.ttest.adj <- mt.rawp2adjp(operons.ttest, "BY")$adjp

## flag whether or not the probeset can be considered differentially expressed
operons.diff.expr <- operons.ttest.adj < 0.01
@ 

One needs a little bit of bookkeeping to know what belongs to which operon.
We can build a list of indexes to know what belongs to where:
<<>>=
operons.i <- split(seq(along=operons.ttest), ecoligenome.operon$operon.name)
@ 

The thrill is then to see if the results for differential expression
(or non-differential expression) are homogeneous among the genes within the same operon\ldots

%% First, we want to apply the vsn transformation to our data:
%% <<>>=
%% library(vsn)
%% abatch.n <- normalize(ecoliLeucine, method="vsn")
%% @ 
%% Obtaining the intensities for the probe sets in a particular operon can be done simply
%% (here for the $18^{\mathtt{th}}$ operon in our list).
%% <<>>=
%% ## name of the operon
%% names(affyoperons)[18]
%% ## get the probe sets
%% ppsetoperons <- probeset(abatch.n, affyoperons[[18]])
%% @ 

%% To compute on the probe intensities
%% within an operon, the method \Rfunction{ppsetApply} is helpful.
%% The following example shows how to compute the variance for the probes
%% within an operon:
%% <<>>=
%% ppset.fun <- function(ppset, fun, pmcorrect.fun = pmcorrect.pmonly, transfo.fun=log, ...) {
%%   probes <- do.call("pmcorrect.fun", list(ppset))
%%   probes <- transfo.fun(probes)
%%   r <- apply(probes, 1, fun, ...)
%%   return(r)
%% }

%% r <- ppsetApply(ecoliLeucine, ppset.fun, affyoperons[[18]], fun=var, na.rm=TRUE)
%% @ 
%% Note that we log-transform the probe intensities to work on the the generalized-log transform
%% (as 'vsn' returns the exponential of the g-log transform)
%% <<fig=TRUE>>=
%% boxplot(r)
%% @ 


%% <<>>=
%% var.boot <- function(x, na.rm=TRUE) {
%%   f <- function(d, i) { var(d[i], na.rm=na.rm) }
%%   boot(x, f, R=999, stype="i")
%% }

%% r.boot <- ppsetApply(ecoliLeucine, ppset.fun, affyoperons[[18]], fun=var.boot, na.rm=TRUE)
%% @ 

\end{document}

\name{ecoli.m52.genome}
\alias{ecoli.m52.genome}
\alias{ecoligenomeCHRLOC}
\alias{ecoligenomeSYMBOL2AFFY}
\alias{ecoligenomeSYMBOL}
\alias{ecoligenomeSTRAND}
\alias{ecoli.operon}
\alias{ecoli.len}
%\docType{data}
\title{ Escherichia coli data}
\description{
  Meta-data related to Escherichia coli
}
\usage{
data(ecoli.m52.genome)
data(ecoligenomeCHRLOC)
data(ecoligenomeSYMBOL2AFFY)
data(ecoligenomeSYMBOL)
data(ecoligenomeSTRAND)
data(ecoligenome.operon)
ecoli.len
}
\format{
  The format for \code{ecoli.m52.genome} is \code{character}
  with genome sequence.
  The format for \code{ecoligenomeCHRLOC} is
  an environment (as a hash table). Each key
  is an Affyemtrix probe set ID, and each value is vector of
  two integers (begining and end - see the details
  below)
  The format for \code{ecoligenomeSYMBOL2AFFFY}
  is an environment (as a hash table). Each key is
  a gene symbol name.
  The format for \code{ecoligenomeSYMBOL}
  is an environment (as a hash table). Each key
  is an Affymetrix probe set id
  \code{ecoli.len} is a variable containing the size of the genome in
  \code{ecoli.m52.genome}.
}
\details{
  The environments \code{ecoligenomeSYMBOL2AFFFY} and
  \code{ecoligenomeSYMBOL} are like the ones in the
  data packages built by \code{annBuilder}.
  
  The environment
  \code{ecoligenomeCHRLOC} differs: two integers are associated
  with each key, one corresponds to the begining of the segment
  the other to the end.

  The environment ecoligenomeSTRAND returns a \code{logical}.
  \code{TRUE} means that the orientation is `+', \code{FALSE} means
  that the orientation is '-' (and \code{NA} is used when irrelevant
  for the key).
  
}
\source{
  \url{http://www.genome.wisc.edu/sequencing/k12.htm} and
  \url{http://www.biostat.harvard.edu/complab/dchip/info_file.htm}
}

\examples{
data(ecoli.m52.genome)


}
\keyword{datasets}

\name{ecoligenomeBNUM2MULTIFUN}
\alias{ecoligenomeBNUM2MULTIFUN}
\alias{ecoligenomeBNUM2STRAND}
\docType{data}
\title{ Environment }
\description{
  An environment to store associtations between 'bnum' identifiers (key)
  and 'MultiFun' identifiers (or strand information).
}
\usage{data(ecoligenomeBNUM2MULTIFUN)}
\format{
  The format is:
length 0 <environment>
 - attr(*, "comments")= chr "GenProtEC: MultiFun assignments for E. coli modules
September 17th, 2003"
}
\details{
  'MultiFun' is a classification scheme. The structure is
  'approximately tree-like'.
  Several 'MultiFun' numbers can be assigned to one 'bnum'.
}
\source{
  "http://genprotec.mbl.edu/files/MultiFun.txt"
}
\keyword{datasets}

\name{pointsCircle}
\alias{linesCircle}
\alias{polygonDisk}
\alias{arrowsArc}
\alias{pointsArc}
\alias{linesArc}
\alias{polygonArc}
\title{ Functions to plot circular related figures }
\description{
  Functions to plot circular related figures
}
\usage{
linesCircle(radius, center.x = 0, center.y = 0, edges = 300, ...)
polygonDisk(radius, center.x = 0, center.y = 0, edges=300,
...)
arrowsArc(theta0, theta1, radius, center.x = 0, center.y = 0, edges = 10,
          length = 0.25, angle = 30, code = 2, ...)
pointsArc(theta0, theta1, radius, center.x = 0, center.y = 0, ...)
linesArc(theta0, theta1, radius, center.x = 0, center.y = 0, ...)
polygonArc(theta0, theta1, radius.in, radius.out,
           center.x = 0, center.y = 0,
           edges = 10,
           col = "black",
           border = NA,
           ...)
}
\arguments{
  \item{theta0, theta1}{ start and end angles for the arc}
  \item{radius}{ radius of the circle }
  \item{radius.in}{ inner radius }
  \item{radius.out}{ outer radius }
  \item{center.x, center.y}{Coordinates for the center of the circle
    (default to (0, 0))}
  \item{edges}{ number of edges the shape is made of }
  \item{col}{color}
  \item{border}{border (see \code{\link[graphics]{polygon}})}
  \item{length, angle, code}{see the corresponding parameters for the
    function \code{\link{arrows}}}
  \item{\dots}{ optional graphical paramaters}
}
\details{
  Details to come\ldots for now the best to run the examples and experiment by
  yourself\ldots
%%  The functions \code{linesArc}, \code{pointsArc}, \code{arrowsArc} 
}
\value{
  Function only used for their border effects.
}
\author{ laurent }
\examples{
par(mfrow=c(2,2))
n <- 10
thetas <- rev(seq(0, 2 * pi, length=n))

rhos <- rev(seq(1, n) / n)

xy <- polar2xy(rhos, thetas)
colo <- heat.colors(n)

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n")
for (i in 1:n)
  linesCircle(rhos[i]/2, xy$x[i], xy$y[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n")
for (i in 1:n)
  polygonDisk(rhos[i]/2, xy$x[i], xy$y[i], col=colo[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n", xlab="", ylab="")
for (i in 1:n)
  polygonArc(0, thetas[i],
             rhos[i]/2, rhos[i],
             center.x = xy$x[i], center.y = xy$y[i], col=colo[i])

plot(0, 0, xlim=c(-2, 2), ylim=c(-2, 2), type="n", xlab="", ylab="")
for (i in (1:n)[-1]) {
  linesCircle(rhos[i-1], col="gray", lty=2)
  polygonArc(thetas[i-1], thetas[i],
             rhos[i-1], rhos[i], col=colo[i],
             edges=20)
  arrowsArc(thetas[i-1], thetas[i],
             rhos[i] + 1, col=colo[i],
             edges=20)
}
  
}
\keyword{ aplot }

\name{polygonChrom}
\alias{polygonChrom}
\alias{linesChrom}
\alias{cPlotCircle}
\alias{chromPos2angle}
\title{ Functions to plot circular chromosomes informations }
\description{
  Functions to plot circular chromosomes informations
}
\usage{
cPlotCircle(radius=1, xlim=c(-2, 2), ylim=xlim, edges=300, main=NULL,
            main.inside, ...)

chromPos2angle(pos, len.chrom, rot=pi/2, clockwise=TRUE)

polygonChrom(begin, end, len.chrom, radius.in, radius.out,
             total.edges = 300,
             edges = max(round(abs(end - begin)/len.chrom *
                     total.edges), 2, na.rm = TRUE),
             rot = pi/2, clockwise = TRUE, ...)

linesChrom(begin, end, len.chrom, radius,
             total.edges = 300,
             edges = max(round(abs(end - begin)/len.chrom *
                     total.edges), 2, na.rm = TRUE),
             rot = pi/2, clockwise = TRUE, ...)

ecoli.len
}

\arguments{
  \item{radius}{radius}
  \item{xlim, ylim}{ range for the plot. Can be used to zoom-in a
    particular region.}
  \item{pos}{position (nucleic base coordinate)}
  \item{begin}{ begining of the segment (nucleic base number). }
  \item{end}{ end of the segment (nucleic base number). }
  \item{len.chrom}{ length of the chromosome in base pairs }
  \item{radius.in}{ inner radius }
  \item{radius.out}{ outer radius }
  \item{total.edges}{ total number of edges for the chromosome}
  \item{edges}{ number of edges for the specific segment(s) }
  \item{rot}{ rotation (default is \code{pi / 2}, bringing the angle
    zero at 12 o'clock)}
  \item{clockwise}{ rotate clockwise. Default to \code{TRUE}.  }
  \item{main, main.inside}{main titles for the plot}
  \item{\dots}{ optional graphical parameters }
}
\details{
  The function \code{chromPos2angle} is a convenience function.
  The variable ecoli.len contains the size of the Escheria coli genome
  considered (K12).
}
\value{
  Except \code{chromPos2angle}, the function are solely used for their
  border effects.
}
\author{ laurent <laurent@cbs.dtu.dk>}
\seealso{  }
\examples{

data(ecoligenomeSYMBOL2AFFY)
data(ecoligenomeCHRLOC)

## find the operon lactose ("lac*" genes)
lac.i <- grep("^lac", ls(ecoligenomeSYMBOL2AFFY))
lac.symbol <- ls(ecoligenomeSYMBOL2AFFY)[lac.i]
lac.affy <- unlist(lapply(lac.symbol, get, envir=ecoligenomeSYMBOL2AFFY))

beg.end <- lapply(lac.affy, get, envir=ecoligenomeCHRLOC)
beg.end <- matrix(unlist(beg.end), nc=2, byrow=TRUE)

lac.o <- order(beg.end[, 1])

lac.i <- lac.i[lac.o]
lac.symbol <- lac.symbol[lac.o]
lac.affy <- lac.affy[lac.o]
beg.end <- beg.end[lac.o, ]

lac.col <- rainbow(length(lac.affy))

par(mfrow=c(2,2))

## plot

cPlotCircle(main="lac genes")
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.2, col=lac.col)
rect(0, 0, 1.1, 1.1, border="red")

cPlotCircle(xlim=c(0, 1.2), ylim=c(0, 1.1))
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.1, col=lac.col)
rect(0.4, 0.8, 0.7, 1.1, border="red")

cPlotCircle(xlim=c(.45, .5), ylim=c(.85, 1.0))
polygonChrom(beg.end[, 1], beg.end[, 2], ecoli.len, 1, 1.03, col=lac.col)

mid.genes <- apply(beg.end, 1, mean)
mid.angles <- chromPos2angle(mid.genes, ecoli.len)
xy <- polar2xy(1.03, mid.angles)
xy.labels <- data.frame(x = seq(0.45, 0.5, length=4), y = seq(0.95, 1.0, length=4))
segments(xy$x, xy$y, xy.labels$x, xy.labels$y, col=lac.col)
text(xy.labels$x, xy.labels$y, lac.symbol, col=lac.col)

}
\keyword{ hplot}
\keyword{ dplot}

\name{polar2xy}
\alias{polar2xy}
\alias{xy2polar}
\alias{rotate}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Functions to perform polar coordinate related functions}
\description{
  Functions to perform polar coordinate related functions
}
\usage{
polar2xy(rho, theta)
xy2polar(x, y)
rotate(x, y, alpha)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ cartesian coordinate }
  \item{y}{ cartesian coordinate  }
  \item{rho}{ polar radius \code{rho} }
  \item{theta}{ polar angle \code{theta}}
  \item{alpha}{ angle to perform rotation }
}
\details{
  \code{y} and \code{theta} can be respectively missing. In this case,
  \code{x} and \code{rho} are expected to be lists with entries
  \code{x, y}, \code{rho, theta} respectively.
}
\value{
  %Lists of
  %\item x,y
  %or
  %\item rho, theta.
}
\examples{


n <- 40
nn <- 2
thetas <- seq(0, nn * 2 * pi, length=n)

rhos <- seq(1, n) / n

plot(c(-1, 1), c(-1, 1), type="n")
abline(h=0, col="grey")
abline(v=0, col="grey")

xy <- polar2xy(rhos, thetas)

points(xy$x, xy$y, col=rainbow(n))

}
\keyword{ manip}

\name{wstringapply}
\alias{wstringapply}
\title{ Apply a function on a window sliding on a string }
\description{
  Apply a function on a window sliding on a string.
}
\usage{
wstringapply(x, SIZE, SLIDE, FUN, ...)
}
\arguments{
  \item{x}{ The string }
  \item{SIZE}{ The size of the window (number of characters). }
  \item{SLIDE}{ offset to move at each slide}
  \item{FUN}{ The function to be applied }
  \item{\dots}{ optional parameter for the function \code{FUN} }
}
\details{
  Apply the function \code{FUN} to substrings of \code{x} of length \code{SIZE}.
}
\value{
  A list of size \code{nchar(x) - SIZE}.
}
\author{ L, Gautier }
\examples{
}
\keyword{ manip }

\name{ecoligenome.operon}
\alias{ecoligenome.operon}
\docType{data}
\title{ Known operon in E.coli - data.frame}
\description{
  The known operon in the Escherichia coli genome.
}
\usage{data(ecoligenome.operon)}
\format{
  A data frame with 932 observations (genes) on the following 4 variables.
  \describe{
    \item{gene.name}{a character vector}
    \item{gene.annotation}{a character vector}
    \item{operon.name}{a factor with levels the names of the operons}
    \item{operon.comments}{a factor with levels the comments for the operons}
  }
}
\details{
  For some operons, the source of information specifies the existence of
  regulating elements such as promoter, terminator, box, etc\ldots
  In those cases, the \code{gene.name} is set to \code{"Regulation"},
  and the \code{gene.annotation} gives what kind of regulating element
  it is. If volonteers, it would be neat to map those on the genome\ldots
  Besides that, not much to add. The data structure is fairly straightforward.
}
\source{
  Built from the webpage:
  \url{http://www.cib.nig.ac.jp/dda/backup/taitoh/ecoli.operon.html}
}
% \references{
%   ~~ possibly secondary sources and usages ~~
% }
\examples{
library(Biobase)
data(ecoligenome.operon)
data(ecoligenomeSYMBOL2AFFY)

## something that might be useful when working with Affymetrix data:
## get the Affymetrix identifiers for the probe sets bundled in operons
## (see the vignette for more details)
ecoligenome.operon$affyid <-
unname(unlist(mget(ecoligenome.operon$gene.name,
                   ecoligenomeSYMBOL2AFFY, ifnotfound=NA)))

}
\keyword{datasets}

\name{linkedmultiget}
\alias{linkedmultiget}
\title{ A function to look for values across linked environments}
\description{
  A function to look for values across linked environments.
}
\usage{
linkedmultiget(x, envir.list = list(), unique = TRUE)
}

\arguments{
  \item{x}{The keys in the first environment in the list.}
  \item{envir.list}{A list of environments.}
  \item{unique}{Simplify the list returned by ensuring that the values
    for each key are unique.}
}
\details{
  Environments can be considered as hashtables. The keys are obviously
  strings, but in some cases the associated values are also
  strings. This is the case for annotation environments (as built with
  the package \code{AnnBuilder}). This function helps to look for values
  across several environments: the keys have associated values in a
  first environment, these values are used as keys in the second
  environments, etc...
}
\value{
  A list of length the length of \code{x}.
}
\author{ Laurent Gautier }
\seealso{ \code{\link{mget}} }
\examples{
data(ecoligenomeBNUM)
data(ecoligenomeBNUM2MULTIFUN)
data(multiFun)

## get 5 Affymetrix IDs
set.seed(456)
my.affyids <- sample(ls(ecoligenomeBNUM), 5)

## get the MULTIFUN annotations for them
r <- linkedmultiget(my.affyids, list(ecoligenomeBNUM,
                    ecoligenomeBNUM2MULTIFUN, multiFun))

print(r)
}
\keyword{ manip }

\name{gccontent}
\alias{gccontent}
\title{ function to compute gccontent }
\description{
  A simple R function to compute the GC content of a sequence
}
\usage{
gccontent(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ a vector of mode \code{character} }
}
\details{
  This a simple (and not particularly fast) function to compute the GC
  content of sequence. When speed is an issue, one should use the
  function in the package \code{matchprobes}. This function only exists
  to avoid dependency on this package.
}
\value{
  The GC content (\code{numeric})
}
%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\keyword{ manip }% at least one, from doc/KEYWORDS

\name{ecoligenomeBNUM}
\alias{ecoligenomeBNUM}
\alias{ecoligenomeBNUM2SYMBOL}
\alias{ecoligenomeBNUM2ENZYME}
\alias{ecoligenomeBNUM2GENBANK}
\alias{ecoligenomeBNUM2GENEPRODUCT}
\alias{ecoligenomeSYMBOL2BNUM}
\docType{data}
\title{ Environment for 'bnum' identifiers}
\description{
  Environments to associate Affymetrix probe set IDs with 'bnum' IDs
}
\usage{
data(ecoligenomeBNUM)
data(ecoligenomeBNUM2SYMBOL)
data(ecoligenomeBNUM2ENZYME)
data(ecoligenomeBNUM2GENBANK)
data(ecoligenomeBNUM2GENEPRODUCT)
data(ecoligenomeSYMBOL2BNUM)
}
\format{
  These are \code{environment} objects.
}
\details{
  Escherichia coli genes are sometimes identified by 'bnum's. This
  identfier is typically a 'b' followed by digits.  
}
\source{
  BNUM numbers were parsed out of the Affymetrix identifiers.
  BNUM2* were obtained from the GenProtEC website.
}
\keyword{datasets}

\name{multiFun}
\alias{multiFun}
\alias{ecoligenomeMULTIFUN2GO}
\docType{data}
\title{multiFun classification}
\description{
  The MultiFun classification scheme
}
\usage{
data(multiFun)
data(ecoligenomeMULTIFUN2GO)
}
\format{
These are environments.
}
\details{
  
}
\source{
\url{http://genprotec.mbl.edu/files/MultiFun.txt}
}
\examples{
## To be done...
}
\keyword{datasets}
